"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
// Synchronous promise stubs

function FakeResolve(value) {
  return function () {
    return {
      then: function then(thenFunc) {
        thenFunc(value);
        return {
          catch: function _catch() {}
        };
      }
    };
  };
}

function FakeReject(error) {
  return function () {
    return {
      then: function then() {
        return {
          catch: function _catch(catchFunc) {
            catchFunc(error);
          }
        };
      }
    };
  };
}

exports.FakeResolve = FakeResolve;
exports.FakeReject = FakeReject;