'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.mergeResolvers = mergeResolvers;
exports.mergeSchemas = mergeSchemas;
function mergeResolvers(a, b) {
  return _extends({}, a, b, {
    RootQuery: _extends({}, a.RootQuery, b.RootQuery),
    RootMutation: _extends({}, a.RootMutation, b.RootMutation)
  });
}

/*
 * Obviosly this is the wrong way to do this, but it was a quick start.
 * TODO -- merge the individually parsed schemas.
 */

var rootQueryRE = /(type RootQuer(?:y|ies) \{\n)([\s\S]*?\n*)(\}\s*)/;
var rootMutationRE = /(type RootMutations? \{\n)([\s\S]*?\n*)(\}\s*)/;
var schemaRE = /(schema \{\n)([\s\S]*?\n?)(\}\s*)/;

function mergeSchemas(_schemas) {
  var rootQueries = [];
  var rootMutations = [];
  var outSchemas = [];

  _schemas.forEach(function (_schema) {
    outSchemas.push(_schema.replace(rootQueryRE, function (match, start, queries) {
      rootQueries.push(queries);
      return '';
    }).replace(rootMutationRE, function (match, start, mutations) {
      rootMutations.push(mutations);
      return '';
    }).replace(schemaRE, ''));
  });

  var finalSchema = '\n' + outSchemas.join('') + '\ntype RootQuery {\n' + rootQueries.join('') + '\n}\ntype RootMutation {\n' + rootMutations.join('') + '\n}\nschema {\n  query: RootQuery,\n  mutation: RootMutation\n}\n  ';

  return finalSchema;
}